from .bits import BitSequence as BitSequence
from .ftdi import Ftdi as Ftdi
from _typeshed import Incomplete
from typing import List, Tuple, Union

class JtagError(Exception): ...

class JtagState:
    name: Incomplete
    modes: Incomplete
    exits: Incomplete
    def __init__(self, name: str, modes: Tuple[str, str]) -> None: ...
    def setx(self, fstate: JtagState, tstate: JtagState): ...
    def getx(self, event): ...
    def is_of(self, mode: str) -> bool: ...

class JtagStateMachine:
    states: Incomplete
    def __init__(self) -> None: ...
    def __getitem__(self, name: str) -> JtagState: ...
    def state(self) -> JtagState: ...
    def state_of(self, mode: str) -> bool: ...
    def reset(self) -> None: ...
    def find_path(
        self, target: Union[JtagState, str], source: Union[JtagState, str, None] = ...
    ) -> List[JtagState]: ...
    @classmethod
    def get_events(cls, path): ...
    def handle_events(self, events) -> None: ...

class JtagController:
    TCK_BIT: int
    TDI_BIT: int
    TDO_BIT: int
    TMS_BIT: int
    TRST_BIT: int
    JTAG_MASK: int
    FTDI_PIPE_LEN: int
    direction: Incomplete
    def __init__(self, trst: bool = ..., frequency: float = ...) -> None: ...
    def configure(self, url: str) -> None: ...
    def close(self, freeze: bool = ...) -> None: ...
    def purge(self) -> None: ...
    def reset(self, sync: bool = ...) -> None: ...
    def sync(self) -> None: ...
    def write_tms(self, tms: BitSequence, should_read: bool = ...) -> None: ...
    def read(self, length: int) -> BitSequence: ...
    def write(self, out: Union[BitSequence, str], use_last: bool = ...): ...
    def write_with_read(self, out: BitSequence, use_last: bool = ...) -> int: ...
    def read_from_buffer(self, length) -> BitSequence: ...
    @property
    def ftdi(self) -> Ftdi: ...

class JtagEngine:
    def __init__(self, trst: bool = ..., frequency: float = ...) -> None: ...
    @property
    def state_machine(self): ...
    @property
    def controller(self): ...
    def configure(self, url: str) -> None: ...
    def close(self, freeze: bool = ...) -> None: ...
    def purge(self) -> None: ...
    def reset(self) -> None: ...
    def write_tms(self, out, should_read: bool = ...) -> None: ...
    def read(self, length): ...
    def write(self, out, use_last: bool = ...) -> None: ...
    def get_available_statenames(self): ...
    def change_state(self, statename) -> None: ...
    def go_idle(self) -> None: ...
    def write_ir(self, instruction) -> None: ...
    def capture_ir(self) -> None: ...
    def write_dr(self, data) -> None: ...
    def read_dr(self, length: int) -> BitSequence: ...
    def capture_dr(self) -> None: ...
    def sync(self) -> None: ...
    def shift_register(self, out: BitSequence) -> BitSequence: ...
    def shift_and_update_register(self, out: BitSequence) -> BitSequence: ...

class JtagTool:
    def __init__(self, engine) -> None: ...
    def idcode(self) -> None: ...
    def preload(self, bsdl, data) -> None: ...
    def sample(self, bsdl): ...
    def extest(self, bsdl) -> None: ...
    def readback(self, bsdl): ...
    def detect_register_size(self) -> int: ...
